#class auto
#nodebug
//==================================================================
//
//  Generic Header information generated by 13705CFG.EXE (Build 9)
//
//  Copyright (c) 2000,2001 Epson Research and Development, Inc.
//  All rights reserved.
//
//  Panel: 320x240x4bpp 113Hz Color 8-Bit STN, Format 2 (PCLK=20.000MHz)
//
//  This file defines the configuration environment and registers,
//  which can be used by any software, such as display drivers.
//
//  PLEASE NOTE: If you FTP this file to a non-Windows platform, make
//               sure you transfer this file using ASCII, not BINARY
//               mode.
//
//==================================================================

#define S1D_DISPLAY_WIDTH               320
#define S1D_DISPLAY_HEIGHT              240
#define S1D_DISPLAY_BPP                 4
#define S1D_DISPLAY_SCANLINE_BYTES      160
#define S1D_DISPLAY_FRAME_RATE          113
#define S1D_DISPLAY_PCLK                20000000L
#define S1D_PHYSICAL_REG_ADDR           0x0002FFE0L
#define S1D_PHYSICAL_VMEM_ADDR          0x00010000L
#define S1D_PHYSICAL_REG_SIZE           31L
#define S1D_PHYSICAL_VMEM_SIZE          81920L
#define S1D_PALETTE_SIZE                256
#define S1D_FRAME_RATE                  113
#define S1D_POWER_DELAY_OFF             500
#define S1D_POWER_DELAY_ON              0
#define S1D_REGDELAYOFF                 0xFE
#define S1D_REGDELAYON                  0xFF

typedef unsigned char S1D_INDEX;
typedef unsigned char S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

const static S1D_REGS aS1DRegs[] =
{
    { 0x00,             0x24 },       // Revision Code Register
    { 0x01,             0x3B },       // Mode Register 0 Register
    { 0x02,             0xB0 },       // Mode Register 1 Register
    { 0x03,             0x03 },       // Mode Register 2 Register (enable display)
    { 0x04,             0x27 },       // Horizontal Panel Size Register
    { 0x05,             0xEF },       // Vertical Panel Size Register (LSB)
    { 0x06,             0x00 },       // Vertical Panel Size Register (MSB)
    { 0x07,             0x1F },       // FPLINE Start Position Register
    { 0x08,             0x00 },       // Horizontal Non-Display Period Register
    { 0x09,             0x00 },       // FPFRAME Start Position Register
    { 0x0A,             0x0B },       // Vertical Non-Display Period Register
    { 0x0B,             0x00 },       // MOD Rate Register
    { 0x0C,             0x00 },       // Screen 1 Start Address Register (LSB)
    { 0x0D,             0x00 },       // Screen 1 Start Address Register (MSB)
    { 0x0E,             0x00 },       // Screen 2 Start Address Register (LSB)
    { 0x0F,             0x00 },       // Screen 2 Start Address Register (MSB)
    { 0x10,             0x00 },       // Screen Start Address Overflow Register
    { 0x11,             0x00 },       // Memory Address Offset Register
    { 0x12,             0xFF },       // Screen 1 Vertical Size Register (LSB)
    { 0x13,             0x03 },       // Screen 1 Vertical Size Register (MSB)
    { 0x18,             0x00 },       // GPIO Configuration Control Register
    { 0x19,             0x02 },       // GPIO Status/Control Register
    { 0x1A,             0x00 },       // Scratch Pad Register
    { 0x1B,             0x00 },       // SwivelView Mode Register
    { 0x1C,             0xA0 },       // Line Byte Count Register
};
#define S1DNUMREGS 25
#define S1DREGOFFSET 0xFFE0
#define S1DMEMSIZE 38400
/*
** Look-Up Table - 8 elements.
*/
typedef union {
	unsigned char RGB[3];
} triplet;

const triplet VGApalette[16]= {
{	0x00, 0x00, 0x00},		/* BLACK  */
{	0x00, 0x00, 0xA0},		/* BLUE   */
{	0x00, 0xA0, 0x00},		/* GREEN  */
{	0x00, 0xA0, 0xA0},		/* CYAN   */
{	0xA0, 0x00, 0x00},		/* RED    */
{	0xA0, 0x00, 0xA0},		/* PURPLE */
{	0xA0, 0xA0, 0x00},		/* YELLOW */
{	0xA0, 0xA0, 0xA0},		/* WHITE  */
{	0x00, 0x00, 0x00},		/* BLACK  */
{	0x00, 0x00, 0xF0},		/* LT BLUE   */
{	0x00, 0xF0, 0x00},		/* LT GREEN  */
{	0x00, 0xF0, 0xF0},		/* LT CYAN   */
{	0xF0, 0x00, 0x00},		/* LT RED    */
{	0xF0, 0x00, 0xF0},		/* LT PURPLE */
{	0xF0, 0xF0, 0x00},		/* LT YELLOW */
{	0xF0, 0xF0, 0xF0}			/* LT WHITE  */
};

#define S1D_WRITE_PALETTEi(i,r,g,b)  \
  {  \
  write13705(S1DREGOFFSET+0x15,i); \
  write13705(S1DREGOFFSET+0x17,r); \
  write13705(S1DREGOFFSET+0x17,g); \
  write13705(S1DREGOFFSET+0x17,b); \
  }

#define S1D_READ_PALETTEi(i,r,g,b)   \
  {  \
  write13705(S1DREGOFFSET+0x15,i); \
  r = read13705(S1DREGOFFSET+0x17); \
  g = read13705(S1DREGOFFSET+0x17); \
  b = read13705(S1DREGOFFSET+0x17); \
  }


#asm root
read13705::
		call addressbus		; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld hl,PBDR				; apunta a port paralelo
      ioi res 7,(HL)			; baja RD
rwait:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,rwait				; espera hasta que NOWAIT
      ioi ld a,(PADR) 		; lee dato
      ioi set 7,(HL)			; sube RD
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ld h,0
      ld l,a
      ret

write13705::
		call addressbus		; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld hl,(sp+4)			; lee dato
      ld a,l
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait				; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ld a,0x80
      ioi ld (SPCR),a		; A= entradas
      ret

addressbus:
		ld hl,(sp+4)			; lee address
      ex de,hl					; en DE
ab2:	ld hl,PEDR				; apunta a port
		ioi ld (hl),d			; pone parte alta
		ld hl,PDDR				; apunta a port
		ioi ld (hl),e			; pone parte baja
		ld hl,PCDR				; apunta a port paralelo
		ioi set 0,(hl)			; BHE=1
		rrc e						; debo activar BHE ? (test LSB=1)
		jr nc,ok1	  			; no
      ioi res 0,(HL)			; s, BHE=0
ok1:
		ret



;IY: address
;(IX+0): data left
;(IX+1): data right
writew13705::
		ld hl,iy					; get A15-A0
      ex de,hl					; in DE
		call ab2					; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld a,(IX+0)				; lee dato
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait1:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait1			; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
		ld hl,iy					; lee address
		inc hl					; inc address
      ex de,hl					; A15-A0 in DE
      call ab2					; address bus
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld a,(IX+1)				; lee dato
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait2:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait2			; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ld a,0x80
      ioi ld (SPCR),a		; A= entradas
      ret


xdumpblk::
		ld		a,xpc								; save the frame pointer, and xpc
		push	af
		push	ix

		ld		de,0xe000						; de=lsw(dest)-0xe000
		ld		hl,(sp+8)
		or		a
		sbc	hl,de
		ex		de,hl
		ld		hl,(sp+9)						; hl:e=(dest-0xe000)>>8
		jr		nc,.xcbf_1
		dec	h
.xcbf_1:
		ld		l,d

		add	hl,hl								; h=(dest-0xe000)>>12
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld		a,h
		ld		xpc,a								; xpc=(dest-0xe000)>>12

		ex		de,hl								; calculate the offset in xpc window
		ld		a,h								;    ix=(dest&0x0fff)|0xe000
		and	0x0f
		or		0xe0
		ld		h,a
		ld		ix,hl

		ld		iy,(sp+6)						; a:iy=dest, hl=length
		ld		hl,(sp+12)

											; count words not bytes
		ld		c,h								; c:b=length
		ld		b,l
		ld		a,l
		or		a
		jr		nz,xcbf_loop
		dec	c

xcbf_loop:
      call	writew13705						; preserve BC
		ld		de,0x0002						; 6 copying word by word
		add	ix,de								; 4
		add	iy,de								; 4
		djnz	xcbf_loop						; 5, critical path word
      xor	a
		dec	c
		jp		p,xcbf_loop

xcbf_done:
		pop	ix
		pop	af
		ld		xpc,a
		ret
#endasm


void writepalette(triplet *address)
{
int i;
unsigned char *ptr;

	ptr=&(address->RGB[0]);
   BitWrPortI(PCDR,&PCDRShadow,1,4);					// A16=1, all off
  	write13705(0x15+S1DREGOFFSET,0);
	for(i=0;i<16;i++){
     write13705(S1DREGOFFSET+0x17,*ptr++);
	  write13705(S1DREGOFFSET+0x17,*ptr++);
	  write13705(S1DREGOFFSET+0x17,*ptr++);
   }
   BitWrPortI(PCDR,&PCDRShadow,0,4);					// A16=0, all off
}


void init13705()
{
int i;

   BitWrPortI(PCDR,&PCDRShadow,1,4);					// A16=1, all off
	for(i=1;i<S1DNUMREGS;i++)
   	write13705((aS1DRegs[i].Index)+S1DREGOFFSET,aS1DRegs[i].Value);
   BitWrPortI(PCDR,&PCDRShadow,0,4);					// A16=0, all off
   writepalette(VGApalette);
}


void LCD_fill(int address, unsigned int len, unsigned char color)
{
	color|=(color<<4);
	while(len--)
     	write13705(address++,color);						// fill with color
}

#define LCD_clear() LCD_fill(0,S1DMEMSIZE,0)


/* Plot image data, 2 pixels per byte, MSB left */

void LCD_plot (int x, int y, unsigned char color)
{
unsigned int strip,nibble,data;

	strip=x>>1;											// strip = x/2
	nibble=x&'\B01';	  								// nibble = remainder
	y=strip+160*y;										// calculate address
	data=read13705(y);								// get data at that address
	if(nibble){
      data&=0xF0;										// clear pixel bits
		data|=color;									// set pixel color (MSB left)
   }
   else {
      data&=0x0F;
      data|=(color<<4);
   }
	write13705(y,data);
}


/* Read image files, store them as [(long)lenght][data...] in xmem
Image data can be extracted from BMP format (without the header), but
vertically mirrored.
Take a desired image, resize to 320x240, color reduce to 16 colors,
mirror verticaly (rotate 180, flip horizontally).
Save to file, remove 118 byte header with your preferred hex editor
Extract color palette from bytes 54-117 (R G B 0) and reduce to R G B
 */

#ximport "goku16sa.pbm" gokus
#ximport "goku16a.pbm" goku
#ximport "db16a.pbm" db
#ximport "dbz16a.pbm" dbz

const triplet gokuspal[16]= {
	{  8, 13, 14},
	{ 76, 75, 69},
	{191,233,249},
	{102,132,131},
	{250,106, 26},
	{135,161,155},
	{215, 87, 38},
	{116, 41, 12},
	{194,138,109},
	{ 42, 45, 38},
	{248,220,203},
	{146,178,217},
	{164, 80, 31},
	{ 31, 34, 30},
	{151,124,112},
	{236,166,129},
};


const triplet gokupal[16]= {
	{ 38, 50, 52},
	{124,135,128},
	{168,152,156},
	{183,172,146},
	{ 65, 92,118},
	{195,187,171},
	{209,204,194},
	{ 93, 94, 96},
	{223,218,207},
	{133, 92,135},
	{ 51,108,163},
	{129,115, 71},
	{253,252,252},
	{ 48, 93,137},
	{147,114,153},
	{174,137,175},
};

const triplet dbpal[16]= {
	{ 26, 15, 22},
	{208,195,163},
	{ 87,117, 66},
	{187, 76, 36},
	{ 68, 89, 56},
	{180,135, 93},
	{135, 53, 44},
	{ 43, 47, 53},
	{ 40, 56,131},
	{150,133,103},
	{ 73,118,172},
	{ 49, 94,161},
	{103, 51, 40},
	{155, 89, 54},
	{242,241,240},
	{ 98, 18, 38},
};

const triplet dbzpal[16]= {
	{ 24, 22, 28},
	{110,100,100},
	{154,145,119},
	{180,170,147},
	{193,188,169},
	{ 72, 50, 62},
	{210,204,186},
	{135,105, 76},
	{237,226,129},
	{119, 56, 39},
	{209,124,140},
	{183,108, 52},
	{208,143,101},
	{224,219,207},
	{237,234,229},
	{ 52, 62,105},
};


root useix void LCD_dump(long imgdata, triplet *paldata)
{

unsigned int dest,tocopy,len;


	len=S1DMEMSIZE/2;
   dest=0;
   imgdata+=sizeof(long);
   writepalette(paldata);
		while(len) {
			tocopy=2048-(dest&2047);
			if(tocopy>len)
				tocopy=len;
			xdumpblk(dest,imgdata,tocopy);
			dest+=(tocopy<<1);
			imgdata+=(tocopy<<1);
			len-=tocopy;
		}

}


// Bresenham Line Algorithm

void LCD_line(int x1,int y1,int x2,int y2, unsigned char color)
{
int  x,y,dx,dy,incx,incy,balance;

        if (x2 >= x1){
                dx = x2 - x1;
                incx = 1;
        }
        else {
                dx = x1 - x2;
                incx = -1;
        }

        if (y2 >= y1) {
                dy = y2 - y1;
                incy = 1;
        }
        else {
                dy = y1 - y2;
                incy = -1;
        }

        x = x1;
        y = y1;

        if (dx >= dy) {
                dy <<= 1;
                balance = dy - dx;
                dx <<= 1;

                while (x != x2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                y += incy;
                                balance -= dx;
                        }
                        balance += dy;
                        x += incx;
                }
                LCD_plot(x, y,color);
        }
        else {
                dx <<= 1;
                balance = dx - dy;
                dy <<= 1;

                while (y != y2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                x += incx;
                                balance -= dy;
                        }
                        balance += dx;
                        y += incy;
                }
                LCD_plot(x, y,color);
        }
}


#define LCD_rectangle(x1,y1,x2,y2,c) \
{ \
	LCD_line(x1,y1,x2,y1,c); \
	LCD_line(x2,y1,x2,y2,c); \
	LCD_line(x2,y2,x1,y2,c); \
	LCD_line(x1,y2,x1,y1,c); \
}


/* simple 3D function plotting */

void paraboloide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,unsigned char pcolor)
{
auto int xx,yy;
auto float x,y,z;
auto float persp,xt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=160+(int)(SCALE*xt);
			yy=120-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			z=x*x/4+y*y/9-15;
			xt=x-y*cs;
			zt=z-y*si;
			xx=160+(int)(SCALE*xt);
			yy=120-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}

void elipsoide(int PERSP,float SCALE,int TRAZOSX,int TRAZOSY,float X0,float X1,float Y0,float Y1,unsigned char pcolor)
{
auto int xx,yy;
auto float x,y,z;
auto float persp,xt,yt,zt;
auto float h1,h2,h3,h4,cs,si;

	persp=PERSP*0.01745329;			// convert to radians
	cs=cos(persp);
	si=sin(persp);
	h1=(X1-X0)/159;
	h2=(Y1-Y0)/(float)(TRAZOSX-1);
	h3=(X1-X0)/(float)(TRAZOSY-1);
	h4=(Y1-Y0)/159;

	for(y=Y0;y<=Y1;y+=h2)
		for(x=X0;x<=X1;x+=h1){
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=160+(int)(SCALE*xt);
			yy=120-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
	for(x=X0;x<=X1;x+=h3)
		for(y=Y0;y<=Y1;y+=h4) {
			xt=cos(x)*cos(y);
			yt=sin(x)*cos(y);
			zt=sin(y);
			xt-=yt*cs;
			zt-=yt*si;
			xx=160+(int)(SCALE*xt);
			yy=120-(int)(SCALE*zt);
			LCD_plot(xx,yy,pcolor);
		}
}


void MsDelay ( int iDelay )
{
	unsigned long ul0;
	ul0 = MS_TIMER;		// get current timer value
	while ( MS_TIMER < ul0 + (unsigned long) iDelay );
}


main()
{
unsigned int i,j;
const static triplet palgrey[16]= {
{	0x00, 0x00, 0x00},		/* BLACK  */
{	0x10, 0x10, 0x10},
{	0x20, 0x20, 0x20},
{	0x30, 0x30, 0x30},
{	0x40, 0x40, 0x40},
{	0x50, 0x50, 0x50},
{	0x60, 0x60, 0x60},
{	0x70, 0x70, 0x70},
{	0x80, 0x80, 0x80},
{	0x90, 0x90, 0x90},
{	0xA0, 0xA0, 0xA0},
{	0xB0, 0xB0, 0xB0},
{	0xC0, 0xC0, 0xC0},
{	0xD0, 0xD0, 0xD0},
{	0xE0, 0xE0, 0xE0},
{	0xF0, 0xF0, 0xF0}			/* WHITE  */
};

  	WrPortI ( SPCR, &SPCRShadow, 0x80 );		// PA0-7 = Inputs
	WrPortI ( PEDDR,&PEDDRShadow,'\B11111111' );
	WrPortI ( PDDDR,&PDDDRShadow,'\B11111111' );
	WrPortI ( PBDR,&PBDRShadow,'\B11000000' );
	WrPortI ( PCDR,&PCDRShadow,'\B11111111' );
	WrPortI ( PCFR,&PCFRShadow,0 );				// disable prog port (use PC6)

	init13705();
//	printf("ID: %0x\n",read13705(S1DREGOFFSET));
//	for(i=0;i<S1D_PHYSICAL_REG_SIZE;i++)
//		printf("%d: %0x\n",i,read13705(S1DREGOFFSET+i));
/*	for(i=0;i<16;i++){
	   S1D_READ_PALETTEi(i,r,g,b);
		printf("%0x,%0x,%0x\n",r,g,b);
   }
*/

	LCD_clear();
   while(1){
	   writepalette(VGApalette);
 		for(i=0;i<16;i++) {
			LCD_fill(0,S1DMEMSIZE,i);
	   }
		LCD_clear();
 		for(i=0;i<16;i++) {
			LCD_rectangle(10*i,5*i,8*i+120,5*i+40,10);
			LCD_rectangle(7*i,7*i,9*i+120,7*i+42,12);
	   }
		MsDelay ( 5000 );						// wait 5 secs

//		LCD_dump(gokus,gokuspal);				// show gfx
//		MsDelay ( 10000 );					// wait 10 secs
	   writepalette(palgrey);
 		for(j=0;j<38400;)						// show TV adjust screen
	 		for(i=0;i<16;i++,j+=10)
				LCD_fill(j,10,i);
		MsDelay ( 5000 );						// wait 5 secs
	   writepalette(VGApalette);
		MsDelay ( 10000 );					// wait 10 secs
		LCD_clear();
		paraboloide(30,6,20,20,-8.0,8.0,-10.0,10.0,5);
		MsDelay ( 5000 );	 					// wait 5 secs
		elipsoide(45,80.0,30,30,0,6.28,-3.14,3.14,11);
		MsDelay ( 5000 );						// wait 5 secs
		LCD_dump(goku,gokupal);				// show gfx
		MsDelay ( 10000 );					// wait 10 secs
		LCD_dump(db,dbpal);				// show gfx
		MsDelay ( 10000 );					// wait 10 secs
		LCD_clear();
		LCD_dump(dbz,dbzpal);				// show gfx
		MsDelay ( 10000 );					// wait 10 secs
	}
}

